package org.tinyjee.maven.dim;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.plugin.MojoFailureException;

/**
 * Resets project specific paths that were previously set with 'initialize'.
 * <p/>
 * Using this mojo is optional but required in case of 'initialize' is not everywhere in the build but just for specific artifacts.
 *
 * @author Juergen_Kellerer, 2011-10-27
 * @goal reset
 * @inheritByDefault true
 * @executionStrategy always
 * @phase post-site
 * @threadSafe false
 */
public class ResetMojo extends AbstractMojo {
	public void execute() throws MojoExecutionException, MojoFailureException {
		InitializeMacroMojo.reset();
	}
}
