package org.tinyjee.maven.dim.extensions;

import com.thoughtworks.qdox.model.AbstractJavaEntity;
import org.tinyjee.maven.dim.utils.AbstractSelectableJavaEntitiesList;

import java.util.Collection;
import java.util.Map;

/**
 * Implements {@link AbstractSelectableJavaEntitiesList} to let it host output from {@link JavaSourceLoader}.
 *
 * @author Juergen_Kellerer, 2011-10-10
 */
public class SelectableMappedJavaEntitiesList extends AbstractSelectableJavaEntitiesList<Map<String, ?>> {

	private static final long serialVersionUID = -1483709242125352523L;

	private final String qdoxEntityKey;

	public SelectableMappedJavaEntitiesList(Collection<? extends Map<String, ?>> maps, String qdoxEntityKey) {
		super(maps);
		this.qdoxEntityKey = qdoxEntityKey;
	}

	public SelectableMappedJavaEntitiesList(String qdoxEntityKey) {
		this.qdoxEntityKey = qdoxEntityKey;
	}

	@Override
	protected AbstractJavaEntity unwrap(Map<String, ?> element) {
		Object rawEntity = element.get(qdoxEntityKey);
		return rawEntity instanceof AbstractJavaEntity ? (AbstractJavaEntity) rawEntity : null;
	}

	@Override
	@SuppressWarnings("unchecked")
	public SelectableMappedJavaEntitiesList clone() {
		return (SelectableMappedJavaEntitiesList) super.clone();
	}
}
